
//Kirby compatibility
if not(kirbyabilitytable)
	rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["shadowandroid"] = -5

local function GunSearch(refmob, foundmob) 
	if not (foundmob) then
		return nil
	end
	if (foundmob.type == MT_PLAYER) then
		return nil
	end
	
	if ((foundmob.flags & MF_SHOOTABLE) or (foundmob.flags2 & MF2_INVERTAIMABLE)) and (foundmob.health > 0) then
		if (P_CheckSight(refmob, foundmob)) then
			if (refmob.shoottarget)
				if (R_PointToDist2(refmob.x, refmob.y, foundmob.x, foundmob.y) < R_PointToDist2(refmob.x, refmob.y, refmob.shoottarget.x, refmob.shoottarget.y)) then
					refmob.shoottarget = foundmob
				end
			else
				refmob.shoottarget = foundmob
			end
		end
	end

end


addHook("PlayerThink", function(player)
	if (player.mo.skin ~= "shadowandroid") then return end
	if not (player.lasttarget) then
		player.lasttarget = 0
	end
		
	if (player.mo.shoottarget and player.mo.shoottarget.valid) and not (player.pflags & PF_SPINNING)
		player.charability2 = CA2_NONE
		local planedist = R_PointToDist2(player.mo.x, player.mo.y, player.mo.shoottarget.x, player.mo.shoottarget.y)
		player.disttotarget = R_PointToDist2(0, player.mo.z, planedist, player.mo.shoottarget.z)
		local lockon = P_SpawnMobj(player.mo.shoottarget.x, player.mo.shoottarget.y, player.mo.shoottarget.z+(player.mo.shoottarget.height/2), MT_SHADOWLOCKON)
		lockon.target = player.mo.shoottarget
		lockon.flags2 = $|MF2_LINKDRAW
		lockon.scale = FRACUNIT*2
		if (player.disttotarget < 512*FRACUNIT) then
			lockon.state = S_SHADOWLOCKON2
		end
	else
		player.charability2 = CA2_SPINDASH
	end
	
	if (player.hometime ~= nil and player.hometime > -60) then
		if (player.mo.shoottarget == nil) then
			player.hometime = 0
		else
			
			if (player.hometime > 0) then
				local yangle = R_PointToAngle2(player.mo.x, player.mo.y, player.mo.shoottarget.x, player.mo.shoottarget.y)
				local disttotarget = R_PointToDist2(player.mo.x, player.mo.y, player.mo.shoottarget.x, player.mo.shoottarget.y)
				local xangle = R_PointToAngle2(0, player.mo.z, disttotarget, player.mo.shoottarget.z)
				player.mo.momx = FixedMul(cos(yangle), cos(xangle))*40
				player.mo.momy = FixedMul(sin(yangle), cos(xangle))*40
				player.mo.momz = sin(xangle)*40
				local thokitem = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_THOK)
				thokitem.color = player.mo.color
			end
			player.hometime = $-1
		end
	end
	
	if (player.mo.state == S_PLAY_RAPIDFIRE) then
		if  (player.mo.shoottarget and player.mo.shoottarget.valid) and (player.cmd.buttons & BT_USE)  then
			player.drawangle = R_PointToAngle2(player.mo.x, player.mo.y, player.mo.shoottarget.x, player.mo.shoottarget.y)
			if (player.mo.frame == 1 or player.powers[pw_super] > 0) then
				local yangle = player.drawangle
				local disttotarget = R_PointToDist2(player.mo.x, player.mo.y, player.mo.shoottarget.x, player.mo.shoottarget.y)
				local xangle = R_PointToAngle2(0, player.mo.z, disttotarget, player.mo.shoottarget.z)
				local aimpenalty = 5+((player.speed/FRACUNIT)/5)
				xangle = $+(P_RandomRange(-aimpenalty, aimpenalty)*ANG1)
				yangle = $+(P_RandomRange(-aimpenalty, aimpenalty)*ANG1)
															
															
				S_StartSound(player.mo, sfx_s3k4d, player)
				local shot = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+(player.mo.height/2), MT_ANDROIDBULLET)
				shot.target = player.mo
				shot.rollangle = P_RandomFixed()*ANG1
				local shotspeed = 100
				shot.momx = FixedMul(cos(yangle), cos(xangle))*shotspeed
				shot.momy = FixedMul(sin(yangle), cos(xangle))*shotspeed
				shot.momz = sin(xangle)*shotspeed
				P_TeleportMove(shot, shot.x-(shot.momx/2), shot.y-(shot.momy/2), shot.z-(shot.momz/2))
			end
		elseif (player.mo.state == S_PLAY_RAPIDFIRE) then
			player.mo.shoottarget = nil
			player.mo.state = S_PLAY_RUN
		end
	end
	
	if not (player.cmd.buttons & BT_USE) then
		local targetradius = 1024*FRACUNIT
		player.mo.shoottarget = nil
		local searchcenterx = player.mo.x + FixedMul(cos(player.mo.angle),targetradius)
		local searchcentery = player.mo.y + FixedMul(sin(player.mo.angle),targetradius)
		searchBlockmap("objects",GunSearch, player.mo,
			searchcenterx-targetradius,searchcenterx+targetradius,
			searchcentery-targetradius,searchcentery+targetradius)
	end
		
	
end)

addHook("SpinSpecial", function(player)
	if (player.mo.skin ~= "shadowandroid") then return end
	if (player.mo.state == S_PLAY_PAIN) then return end
	if (player.mo.shoottarget) then 
		player.mo.state = S_PLAY_RAPIDFIRE
		return true
	else
		return false
	end
end)

addHook("JumpSpecial", function(player)
	if (player.mo.skin ~= "shadowandroid") then return end
	if (player.mo.state ==S_PLAY_RAPIDFIRE ) then 
		return true
	else
		return false
	end
end)



addHook("AbilitySpecial", function(player)
	if (player.mo.skin ~= "shadowandroid") then return end
	if (player.pflags & PF_THOKKED) then return end
	if (player.mo.shoottarget and player.disttotarget) then 
		if (player.disttotarget < 512*FRACUNIT)
			if not (player.mo.shoottarget == player.lasttarget and player.hometime > -20) then
				player.hometime = 10
				player.mo.state = S_PLAY_JUMP
				player.pflags = $|PF_THOKKED
				S_StartSound(player.mo,sfx_thok,player)
				return true
			end
		end
	end
	
	return false
end)

function A_InterpolatedTrail(actor, var1, var2)

	for i = 0, var1
		P_SpawnMobj(actor.x-((actor.momx/var1)*i),actor.y-((actor.momy/var1)*i), actor.z-((actor.momz/var1)*i), var2)
	end

end

addHook("MobjDamage", function(target, inflictor, source)
	if (source == nil or inflictor == nil or source.player == nil) then return end
	if (source ~= inflictor) then return end
	if (source.skin ~= "shadowandroid") then return end
	if (source.player.hometime and source.player.hometime  > -20) then source.momz = 10*FRACUNIT end
	source.player.hometime = 0
	source.player.lasttarget = target
	S_StartSound(source,sfx_bnce2,source.player)
	source.player.pflags = $ & ~PF_THOKKED
	return true

end)